(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else {
		var a = factory();
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/api/ext-host/ext-host-client-configuration-policy.ts":
/*!******************************************************************!*\
  !*** ./src/api/ext-host/ext-host-client-configuration-policy.ts ***!
  \******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "WebExtHostConfigurationPolicy": () => (/* binding */ WebExtHostConfigurationPolicy)
/* harmony export */ });
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/async */ "@vscode-alt/monaco-editor/esm/vs/base/common/async");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ext_host_client_configuration__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./ext-host-client-configuration */ "./src/api/ext-host/ext-host-client-configuration.ts");


class WebExtHostConfigurationPolicy {
    constructor(proxy, extHostOrganization) {
        this._proxy = proxy;
        this._extHostOrganization = extHostOrganization;
        this._barrier = new _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_0__.Barrier();
        this._actual = null;
    }
    getConfigProvider() {
        return this._barrier.wait().then(_ => this._actual);
    }
    $initializeConfiguration(data) {
        this._actual = new _ext_host_client_configuration__WEBPACK_IMPORTED_MODULE_1__.ExtHostConfigProvider(this._proxy, this._extHostOrganization, data);
        this._barrier.open();
    }
    $acceptConfigurationChanged(data, eventData) {
        this._actual.$acceptConfigurationChanged(data, eventData);
    }
}


/***/ }),

/***/ "./src/api/ext-host/ext-host-client-configuration-role.ts":
/*!****************************************************************!*\
  !*** ./src/api/ext-host/ext-host-client-configuration-role.ts ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "WebExtHostConfigurationRole": () => (/* binding */ WebExtHostConfigurationRole)
/* harmony export */ });
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/async */ "@vscode-alt/monaco-editor/esm/vs/base/common/async");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ext_host_client_configuration__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./ext-host-client-configuration */ "./src/api/ext-host/ext-host-client-configuration.ts");


class WebExtHostConfigurationRole {
    constructor(proxy, extHostOrganization) {
        this._proxy = proxy;
        this._extHostOrganization = extHostOrganization;
        this._barrier = new _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_0__.Barrier();
        this._actual = null;
    }
    getConfigProvider() {
        return this._barrier.wait().then(_ => this._actual);
    }
    $initializeConfiguration(data) {
        this._actual = new _ext_host_client_configuration__WEBPACK_IMPORTED_MODULE_1__.ExtHostConfigProvider(this._proxy, this._extHostOrganization, data);
        this._barrier.open();
    }
    $acceptConfigurationChanged(data, eventData) {
        this._actual.$acceptConfigurationChanged(data, eventData);
    }
}


/***/ }),

/***/ "./src/api/ext-host/ext-host-client-configuration.ts":
/*!***********************************************************!*\
  !*** ./src/api/ext-host/ext-host-client-configuration.ts ***!
  \***********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ExtHostConfigProvider": () => (/* binding */ ExtHostConfigProvider),
/* harmony export */   "WebExtHostConfiguration": () => (/* binding */ WebExtHostConfiguration)
/* harmony export */ });
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_objects__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/objects */ "@vscode-alt/monaco-editor/esm/vs/base/common/objects");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_objects__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_objects__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/uri */ "@vscode-alt/monaco-editor/esm/vs/base/common/uri");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _adminide_stack_extension_api_lib_core_types_ext_host_types__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @adminide-stack/extension-api/lib/core/types/ext-host-types */ "@adminide-stack/extension-api/lib/core/types/ext-host-types");
/* harmony import */ var _adminide_stack_extension_api_lib_core_types_ext_host_types__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_adminide_stack_extension_api_lib_core_types_ext_host_types__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _adminide_stack_core__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @adminide-stack/core */ "@adminide-stack/core");
/* harmony import */ var _adminide_stack_core__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_adminide_stack_core__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_map__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/map */ "@vscode-alt/monaco-editor/esm/vs/base/common/map");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_map__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_map__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_types__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/types */ "@vscode-alt/monaco-editor/esm/vs/base/common/types");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_types__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_types__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/async */ "@vscode-alt/monaco-editor/esm/vs/base/common/async");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! rxjs */ "rxjs");
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_7___default = /*#__PURE__*/__webpack_require__.n(rxjs__WEBPACK_IMPORTED_MODULE_7__);
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! rxjs/operators */ "rxjs/operators");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_8___default = /*#__PURE__*/__webpack_require__.n(rxjs_operators__WEBPACK_IMPORTED_MODULE_8__);
/* harmony import */ var _util_event_pipes__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ../../util/event-pipes */ "./src/util/event-pipes.ts");
/* tslint:disable */










function lookUp(tree, key) {
    if (key) {
        const parts = key.split('.');
        let node = tree;
        for (let i = 0; node && i < parts.length; i++) {
            node = node[parts[i]];
        }
        return node;
    }
}
class WebExtHostConfiguration {
    constructor(proxy, extHostOrganization) {
        this._proxy = proxy;
        this._extHostOrganization = extHostOrganization;
        this._barrier = new _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_6__.Barrier();
        this._actual = null;
    }
    getConfigProvider() {
        return this._barrier.wait().then(_ => this._actual);
    }
    $initializeConfiguration(data) {
        this._actual = new ExtHostConfigProvider(this._proxy, this._extHostOrganization, data);
        this._barrier.open();
    }
    $acceptConfigurationChanged(data, eventData) {
        this._actual.$acceptConfigurationChanged(data, eventData);
    }
    unsubscribe() {
    }
}
class ExtHostConfigProvider {
    constructor(proxy, extHostOrganization, data) {
        this.changed$ = new rxjs__WEBPACK_IMPORTED_MODULE_7__.Subject();
        // get onDidChangeConfiguration(): Event<cdeops.ConfigurationChangeEvent> {
        //     return this._onDidChangeConfiguration && this._onDidChangeConfiguration.event;
        // }
        this.onDidChangeConfiguration = this.changed$.pipe((0,rxjs_operators__WEBPACK_IMPORTED_MODULE_8__.filter)((0,_util_event_pipes__WEBPACK_IMPORTED_MODULE_9__.getEvents)('onDidChangeConfiguration')), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_8__.map)(_util_event_pipes__WEBPACK_IMPORTED_MODULE_9__.getEventPayload));
        this._proxy = proxy;
        this._extHostOrganization = extHostOrganization;
        this._configuration = ExtHostConfigProvider.parse(data);
        this._configurationScopes = data.configurationScopes;
    }
    $acceptConfigurationChanged(data, eventData) {
        this._configuration = ExtHostConfigProvider.parse(data);
        this._configurationScopes = data.configurationScopes;
        // this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(eventData));
        this.changed$.next({ type: 'onDidChangeConfiguration', payload: this._toConfigurationChangeEvent(eventData) });
    }
    getConfiguration(section, resource, extensionId) {
        const config = this._toReadonlyValue(section
            ? lookUp(this._configuration.getValue(null, { resource }, this._extHostOrganization.organization), section)
            : this._configuration.getValue(null, { resource }, this._extHostOrganization.organization));
        if (section) {
            this._validateConfigurationAccess(section, resource, extensionId);
        }
        function parseConfigurationTarget(arg) {
            if (arg === undefined || arg === null) {
                return null;
            }
            if (typeof arg === 'boolean') {
                return arg ? 1 /* ConfigurationTarget.USER */ : 4 /* ConfigurationTarget.ORGANIZATION */;
            }
            switch (arg) {
                case _adminide_stack_extension_api_lib_core_types_ext_host_types__WEBPACK_IMPORTED_MODULE_2__.ConfigurationTarget.Global: return 1 /* ConfigurationTarget.USER */;
                case _adminide_stack_extension_api_lib_core_types_ext_host_types__WEBPACK_IMPORTED_MODULE_2__.ConfigurationTarget.Organization: return 4 /* ConfigurationTarget.ORGANIZATION */;
                case _adminide_stack_extension_api_lib_core_types_ext_host_types__WEBPACK_IMPORTED_MODULE_2__.ConfigurationTarget.OrganizationResource: return 5 /* ConfigurationTarget.ORGANIZATION_RESOURCE */;
            }
        }
        const result = {
            has(key) {
                return typeof lookUp(config, key) !== 'undefined';
            },
            get: (key, defaultValue) => {
                this._validateConfigurationAccess(section ? `${section}.${key}` : key, resource, extensionId);
                let result = lookUp(config, key);
                if (typeof result === 'undefined') {
                    result = defaultValue;
                }
                else {
                    let clonedConfig = undefined;
                    const cloneOnWriteProxy = (target, accessor) => {
                        let clonedTarget = undefined;
                        const cloneTarget = () => {
                            clonedConfig = clonedConfig ? clonedConfig : (0,_vscode_alt_monaco_editor_esm_vs_base_common_objects__WEBPACK_IMPORTED_MODULE_0__.deepClone)(config);
                            clonedTarget = clonedTarget ? clonedTarget : lookUp(clonedConfig, accessor);
                        };
                        return (0,_vscode_alt_monaco_editor_esm_vs_base_common_types__WEBPACK_IMPORTED_MODULE_5__.isObject)(target) ?
                            new Proxy(target, {
                                get: (target, property) => {
                                    if (typeof property === 'string' && property.toLowerCase() === 'tojson') {
                                        cloneTarget();
                                        return () => clonedTarget;
                                    }
                                    if (clonedConfig) {
                                        clonedTarget = clonedTarget ? clonedTarget : lookUp(clonedConfig, accessor);
                                        return clonedTarget[property];
                                    }
                                    const result = target[property];
                                    if (typeof property === 'string') {
                                        return cloneOnWriteProxy(result, `${accessor}.${property}`);
                                    }
                                    return result;
                                },
                                set: (_target, property, value) => {
                                    cloneTarget();
                                    clonedTarget[property] = value;
                                    return true;
                                },
                                deleteProperty: (_target, property) => {
                                    cloneTarget();
                                    delete clonedTarget[property];
                                    return true;
                                },
                                defineProperty: (_target, property, descriptor) => {
                                    cloneTarget();
                                    Object.defineProperty(clonedTarget, property, descriptor);
                                    return true;
                                }
                            }) : target;
                    };
                    result = cloneOnWriteProxy(result, key);
                }
                return result;
            },
            update: (key, value, arg) => {
                key = section ? `${section}.${key}` : key;
                const target = parseConfigurationTarget(arg);
                if (value !== undefined) {
                    return this._proxy.$updateConfigurationOption(target, key, value, resource);
                }
                else {
                    return this._proxy.$removeConfigurationOption(target, key, resource);
                }
            },
            inspect: (key) => {
                key = section ? `${section}.${key}` : key;
                const config = (0,_vscode_alt_monaco_editor_esm_vs_base_common_objects__WEBPACK_IMPORTED_MODULE_0__.deepClone)(this._configuration.inspect(key, { resource }, this._extHostOrganization.organization));
                if (config) {
                    return {
                        key,
                        defaultValue: config.default,
                        globalValue: config.user,
                        organizationValue: config.organization,
                        organizationResourceValue: config.organizationResource
                    };
                }
                return undefined;
            }
        };
        if (typeof config === 'object') {
            (0,_vscode_alt_monaco_editor_esm_vs_base_common_objects__WEBPACK_IMPORTED_MODULE_0__.mixin)(result, config, false);
        }
        return Object.freeze(result);
    }
    _toReadonlyValue(result) {
        const readonlyProxy = (target) => {
            return (0,_vscode_alt_monaco_editor_esm_vs_base_common_types__WEBPACK_IMPORTED_MODULE_5__.isObject)(target) ?
                new Proxy(target, {
                    get: (target, property) => readonlyProxy(target[property]),
                    set: (_target, property, _value) => { throw new Error(`TypeError: Cannot assign to read only property '${property}' of object`); },
                    deleteProperty: (_target, property) => { throw new Error(`TypeError: Cannot delete read only property '${property}' of object`); },
                    defineProperty: (_target, property) => { throw new Error(`TypeError: Cannot define property '${property}' for a readonly object`); },
                    setPrototypeOf: (_target) => { throw new Error(`TypeError: Cannot set prototype for a readonly object`); },
                    isExtensible: () => false,
                    preventExtensions: () => true
                }) : target;
        };
        return readonlyProxy(result);
    }
    _validateConfigurationAccess(key, resource, extensionId) {
        const scope = _adminide_stack_core__WEBPACK_IMPORTED_MODULE_3__.OVERRIDE_PROPERTY_PATTERN.test(key) ? 4 /* ConfigurationScope.RESOURCE */ : this._configurationScopes[key];
        const extensionIdText = extensionId ? `[${extensionId.value}] ` : '';
        if (4 /* ConfigurationScope.RESOURCE */ === scope) {
            if (resource === undefined) {
                console.warn(`${extensionIdText}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${key}', provide the URI of a resource or 'null' for any resource.`);
            }
            return;
        }
        if (3 /* ConfigurationScope.WINDOW */ === scope) {
            if (resource) {
                console.warn(`${extensionIdText}Accessing a window scoped configuration for a resource is not expected. To associate '${key}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);
            }
            return;
        }
    }
    _toConfigurationChangeEvent(data) {
        const changedConfiguration = new _adminide_stack_core__WEBPACK_IMPORTED_MODULE_3__.ConfigurationModel(data.changedConfiguration.contents, data.changedConfiguration.keys, data.changedConfiguration.overrides);
        const changedConfigurationByResource = new _vscode_alt_monaco_editor_esm_vs_base_common_map__WEBPACK_IMPORTED_MODULE_4__.ResourceMap();
        for (const key of Object.keys(data.changedConfigurationByResource)) {
            const resource = _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_1__.URI.parse(key);
            const model = data.changedConfigurationByResource[key];
            changedConfigurationByResource.set(resource, new _adminide_stack_core__WEBPACK_IMPORTED_MODULE_3__.ConfigurationModel(model.contents, model.keys, model.overrides));
        }
        const event = new _adminide_stack_core__WEBPACK_IMPORTED_MODULE_3__.OrganizationConfigurationChangeEvent(new _adminide_stack_core__WEBPACK_IMPORTED_MODULE_3__.ConfigurationChangeEvent(changedConfiguration, changedConfigurationByResource), this._extHostOrganization.organization);
        return Object.freeze({
            affectsConfiguration: (section, resource) => event.affectsConfiguration(section, resource)
        });
    }
    static parse(data) {
        const defaultConfiguration = ExtHostConfigProvider.parseConfigurationModel(data.defaults);
        const userConfiguration = ExtHostConfigProvider.parseConfigurationModel(data.user);
        const organizationConfiguration = ExtHostConfigProvider.parseConfigurationModel(data.organization);
        const folders = Object.keys(data.resources).reduce((result, key) => {
            result.set(_vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_1__.URI.parse(key), ExtHostConfigProvider.parseConfigurationModel(data.resources[key]));
            return result;
        }, new _vscode_alt_monaco_editor_esm_vs_base_common_map__WEBPACK_IMPORTED_MODULE_4__.ResourceMap());
        return new _adminide_stack_core__WEBPACK_IMPORTED_MODULE_3__.Configuration(defaultConfiguration, userConfiguration, new _adminide_stack_core__WEBPACK_IMPORTED_MODULE_3__.ConfigurationModel(), organizationConfiguration, folders, new _adminide_stack_core__WEBPACK_IMPORTED_MODULE_3__.ConfigurationModel(), new _vscode_alt_monaco_editor_esm_vs_base_common_map__WEBPACK_IMPORTED_MODULE_4__.ResourceMap(), false);
    }
    static parseConfigurationModel(model) {
        return new _adminide_stack_core__WEBPACK_IMPORTED_MODULE_3__.ConfigurationModel(model.contents, model.keys, model.overrides).freeze();
    }
}


/***/ }),

/***/ "./src/api/ext-host/ext-host-context.ts":
/*!**********************************************!*\
  !*** ./src/api/ext-host/ext-host-context.ts ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ExtHostContext": () => (/* binding */ ExtHostContext)
/* harmony export */ });
/** @internal */
class ExtHostContext {
    constructor(proxy) {
        this.proxy = proxy;
    }
    updateContext(updates) {
        this.proxy.$acceptContextUpdates(updates);
    }
}


/***/ }),

/***/ "./src/api/ext-host/ext-host-extension-service.ts":
/*!********************************************************!*\
  !*** ./src/api/ext-host/ext-host-extension-service.ts ***!
  \********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "WebExtHostExtensionService": () => (/* binding */ WebExtHostExtensionService)
/* harmony export */ });
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! rxjs */ "rxjs");
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(rxjs__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @adminide-stack/extension-api */ "@adminide-stack/extension-api");
/* harmony import */ var _adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_1__);


class WebExtHostExtensionService {
    constructor() {
        /** Extension's deactivate functions. */
        this.extensionDeactivate = new Map();
    }
    /**
     * Proxy method invoked by the client to load an extension and invoke its `activate` function to start running it.
     *
     * It also sets up global hooks so that when the extension's code uses `require('cdeops/client')` and
     * `import 'cdeops/client'`, it gets the extension API handle (the value specified in
     * cdeops.d.ts).
     *
     * @param extensionID The extension ID of the extension to activate.
     * @param bundleURL The URL to the JavaScript source file (that exports an `activate` function) for
     * the extension.
     * @returns A promise that resolves when the extension's activation finishes (i.e., when it returns if it's synchronous,
     * or when the promise it returns resolves if it's async)
     */
    async $activateExtension(extensionID, bundleURL) {
        // Load the extension bundle and retrieve the extension entrypoint module's exports on
        // the global `module` property.
        try {
            self.exports = {};
            self.module = {};
            self.importScripts(bundleURL);
            console.log("SELF.MODULE: ", self.module);
        }
        catch (err) {
            throw new Error(`error thrown while executing extension ${JSON.stringify(extensionID)}
                bundle (in importScripts of ${bundleURL}): ${err}`);
        }
        const extensionExports = self.module.exports || {};
        delete self.exports;
        delete self.module;
        if (!extensionExports || !('activate' in extensionExports)) {
            throw new Error(`extension bundle for ${JSON.stringify(extensionID)} has no exported activate
                function (in ${bundleURL})`);
        }
        // During extension deactivation, we fist call the extension's `deactivate` function and then unsubscribe
        // the Subscription passed to the `activate` function.
        const extensionSubscriptions = new rxjs__WEBPACK_IMPORTED_MODULE_0__.Subscription();
        const extensionDeactivate = typeof extensionExports.deactivate === 'function' ? extensionExports.deactivate() : null;
        this.extensionDeactivate.set(extensionID, async () => {
            try {
                if (extensionDeactivate) {
                    await Promise.resolve(extensionDeactivate());
                }
            }
            finally {
                extensionSubscriptions.unsubscribe();
            }
        });
        // The behavior should be consistent for both sync and async activate functions that throw
        // errors or reject. Both cases should yield a rejected promise.
        //
        // TODO(sqs): Add timeouts to prevent long-running activate or deactivate functions from
        // significantly delaying other extensions.
        return (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_1__.tryCatchPromise)(() => extensionExports.activate({ subscriptions: extensionSubscriptions })).catch(error => {
            throw Object.assign(new Error(`error during extension ${JSON.stringify(extensionID)} activate function: ${error}`), {
                error,
            });
        });
    }
    async $deactivateExtension(extensionID) {
        const deactivate = this.extensionDeactivate.get(extensionID);
        if (deactivate) {
            this.extensionDeactivate.delete(extensionID);
            return Promise.resolve(deactivate());
        }
    }
    /**
     * Deactivates all activated extensions that have "deactivate" functions. It does not wait for
     * the deactivation to finish for an extension if its deactivate function is async. If any
     * deactivate functions throw an error or reject, the error is logged and not propagated.
     *
     * There is no guarantee that extensions' deactivate functions are called or that execution
     * continues until they are finished. The JavaScript execution context may be terminated before
     * deactivation is completed.
     */
    unsubscribe() {
        for (const [extensionID, deactivate] of this.extensionDeactivate.entries()) {
            this.extensionDeactivate.delete(extensionID);
            (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_1__.tryCatchPromise)(deactivate).catch(err => {
                console.warn(`Error deactivating extension ${JSON.stringify(extensionID)}:`, err);
            });
        }
    }
}


/***/ }),

/***/ "./src/api/ext-host/ext-host-organization.ts":
/*!***************************************************!*\
  !*** ./src/api/ext-host/ext-host-organization.ts ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "WebExtHostOrganization": () => (/* binding */ WebExtHostOrganization)
/* harmony export */ });
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_arrays__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/arrays */ "@vscode-alt/monaco-editor/esm/vs/base/common/arrays");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_arrays__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_arrays__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_event__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/event */ "@vscode-alt/monaco-editor/esm/vs/base/common/event");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_event__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_event__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_map__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/map */ "@vscode-alt/monaco-editor/esm/vs/base/common/map");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_map__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_map__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_platform__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/platform */ "@vscode-alt/monaco-editor/esm/vs/base/common/platform");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_platform__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_platform__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_resources__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/resources */ "@vscode-alt/monaco-editor/esm/vs/base/common/resources");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_resources__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_resources__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_strings__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/strings */ "@vscode-alt/monaco-editor/esm/vs/base/common/strings");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_strings__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_strings__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/uri */ "@vscode-alt/monaco-editor/esm/vs/base/common/uri");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/async */ "@vscode-alt/monaco-editor/esm/vs/base/common/async");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_7___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_7__);
/* harmony import */ var _adminide_stack_core__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @adminide-stack/core */ "@adminide-stack/core");
/* harmony import */ var _adminide_stack_core__WEBPACK_IMPORTED_MODULE_8___default = /*#__PURE__*/__webpack_require__.n(_adminide_stack_core__WEBPACK_IMPORTED_MODULE_8__);









function isResourceEqual(folderA, folderB) {
    return (0,_vscode_alt_monaco_editor_esm_vs_base_common_resources__WEBPACK_IMPORTED_MODULE_4__.isEqual)(folderA, folderB, !_vscode_alt_monaco_editor_esm_vs_base_common_platform__WEBPACK_IMPORTED_MODULE_3__.isLinux);
}
function compareOrganizationResourceByUri(a, b) {
    return isResourceEqual(a.uri, b.uri) ? 0 : (0,_vscode_alt_monaco_editor_esm_vs_base_common_strings__WEBPACK_IMPORTED_MODULE_5__.compare)(a.uri.toString(), b.uri.toString());
}
function compareOrganizationResourceByUriAndNameAndIndex(a, b) {
    if (a.index !== b.index) {
        return a.index < b.index ? -1 : 1;
    }
    return isResourceEqual(a.uri, b.uri) ? (0,_vscode_alt_monaco_editor_esm_vs_base_common_strings__WEBPACK_IMPORTED_MODULE_5__.compare)(a.name, b.name) : (0,_vscode_alt_monaco_editor_esm_vs_base_common_strings__WEBPACK_IMPORTED_MODULE_5__.compare)(a.uri.toString(), b.uri.toString());
}
function delta(oldResources, newResources, compare) {
    const oldSortedResources = oldResources.slice(0).sort(compare);
    const newSortedResources = newResources.slice(0).sort(compare);
    return (0,_vscode_alt_monaco_editor_esm_vs_base_common_arrays__WEBPACK_IMPORTED_MODULE_0__.delta)(oldSortedResources, newSortedResources, compare);
}
class ExtHostOrganizationImpl extends _adminide_stack_core__WEBPACK_IMPORTED_MODULE_8__.OrganizationContext {
    constructor(id, _name, folders) {
        super(id, folders.map(f => new _adminide_stack_core__WEBPACK_IMPORTED_MODULE_8__.OrganizationResource(f)));
        this._name = _name;
        this._organizationResources = [];
        this._structure = _vscode_alt_monaco_editor_esm_vs_base_common_map__WEBPACK_IMPORTED_MODULE_2__.TernarySearchTree.forPaths();
        // setup the organization folder data structure
        folders.forEach(folder => {
            this._organizationResources.push(folder);
            this._structure.set(folder.uri.toString(), folder);
        });
    }
    static toExtHostOrganization(data, previousConfirmedOrganization, previousUnconfirmedOrganization) {
        if (!data) {
            return { organization: null, added: [], removed: [] };
        }
        const { id, name, resources } = data;
        const newOrganizationResources = [];
        // If we have an existing organization, we try to find the folders that match our
        // data and update their properties. It could be that an extension stored them
        // for later use and we want to keep them "live" if they are still present.
        const oldOrganization = previousConfirmedOrganization;
        if (oldOrganization) {
            resources.forEach((folderData, index) => {
                const folderUri = _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_6__.URI.revive(folderData.uri);
                const existingResource = ExtHostOrganizationImpl._findResource(previousUnconfirmedOrganization || previousConfirmedOrganization, folderUri);
                if (existingResource) {
                    existingResource.name = folderData.name;
                    existingResource.index = folderData.index;
                    newOrganizationResources.push(existingResource);
                }
                else {
                    newOrganizationResources.push({ uri: folderUri, name: folderData.name, index });
                }
            });
        }
        else {
            newOrganizationResources.push(...resources.map(({ uri, name, index }) => ({ uri: _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_6__.URI.revive(uri), name, index })));
        }
        // make sure to restore sort order based on index
        newOrganizationResources.sort((f1, f2) => f1.index < f2.index ? -1 : 1);
        const organization = new ExtHostOrganizationImpl(id, name, newOrganizationResources);
        const { added, removed } = delta(oldOrganization ? oldOrganization.organizationResources : [], organization.organizationResources, compareOrganizationResourceByUri);
        return { organization, added, removed };
    }
    static _findResource(organization, folderUriToFind) {
        for (let i = 0; i < organization.resources.length; i++) {
            const folder = organization.organizationResources[i];
            if (isResourceEqual(folder.uri, folderUriToFind)) {
                return folder;
            }
        }
        return undefined;
    }
    get name() {
        return this._name;
    }
    get organizationResources() {
        return this._organizationResources.slice(0);
    }
    getOrganizationResource(uri, resolveParent) {
        if (resolveParent && this._structure.get(uri.toString())) {
            // `uri` is a organization folder so we check for its parent
            uri = (0,_vscode_alt_monaco_editor_esm_vs_base_common_resources__WEBPACK_IMPORTED_MODULE_4__.dirname)(uri);
        }
        return this._structure.findSubstr(uri.toString());
    }
    resolveOrganizationResource(uri) {
        return this._structure.get(uri.toString());
    }
}
class WebExtHostOrganization {
    // private readonly _activeSearchCallbacks: ((match: IRawFileMatch2) => any)[] = [];
    constructor(
    // mainContext: IMainContext,
    proxy, data, logService, requestIdProvider) {
        this._onDidChangeOrganization = new _vscode_alt_monaco_editor_esm_vs_base_common_event__WEBPACK_IMPORTED_MODULE_1__.Emitter();
        // private _messageService: MainThreadMessageServiceShape;
        this.onDidChangeOrganization = this._onDidChangeOrganization.event;
        this._logService = logService;
        this._requestIdProvider = requestIdProvider;
        this._barrier = new _vscode_alt_monaco_editor_esm_vs_base_common_async__WEBPACK_IMPORTED_MODULE_7__.Barrier();
        this._proxy = proxy;
        // this._messageService = mainContext.getProxy(MainContext.MainThreadMessageService);
        this._confirmedOrganization = ExtHostOrganizationImpl.toExtHostOrganization(data).organization;
    }
    // --- organization ---
    get organization() {
        return this._actualOrganization;
    }
    get name() {
        return this._actualOrganization ? this._actualOrganization.name : undefined;
    }
    get _actualOrganization() {
        return this._unconfirmedOrganization || this._confirmedOrganization;
    }
    getOrganizationResources() {
        if (!this._actualOrganization) {
            return undefined;
        }
        return this._actualOrganization.organizationResources.slice(0);
    }
    async getOrganizationResources2() {
        await this._barrier.wait();
        if (!this._actualOrganization) {
            return undefined;
        }
        return this._actualOrganization.organizationResources.slice(0);
    }
    updateOrganizationResources(extension, index, deleteCount, ...organizationResourcesToAdd) {
        const validatedDistinctOrganizationResourcesToAdd = [];
        if (Array.isArray(organizationResourcesToAdd)) {
            organizationResourcesToAdd.forEach(folderToAdd => {
                if (_vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_6__.URI.isUri(folderToAdd.uri) && !validatedDistinctOrganizationResourcesToAdd.some(f => isResourceEqual(f.uri, folderToAdd.uri))) {
                    validatedDistinctOrganizationResourcesToAdd.push({ uri: folderToAdd.uri, name: folderToAdd.name || (0,_vscode_alt_monaco_editor_esm_vs_base_common_resources__WEBPACK_IMPORTED_MODULE_4__.basenameOrAuthority)(folderToAdd.uri) });
                }
            });
        }
        if (!!this._unconfirmedOrganization) {
            return false; // prevent accumulated calls without a confirmed organization
        }
        if ([index, deleteCount].some(i => typeof i !== 'number' || i < 0)) {
            return false; // validate numbers
        }
        if (deleteCount === 0 && validatedDistinctOrganizationResourcesToAdd.length === 0) {
            return false; // nothing to delete or add
        }
        const currentOrganizationResources = this._actualOrganization ? this._actualOrganization.organizationResources : [];
        if (index + deleteCount > currentOrganizationResources.length) {
            return false; // cannot delete more than we have
        }
        // Simulate the updateOrganizationResources method on our data to do more validation
        const newOrganizationResources = currentOrganizationResources.slice(0);
        newOrganizationResources.splice(index, deleteCount, ...validatedDistinctOrganizationResourcesToAdd.map(f => ({ uri: f.uri, name: f.name || (0,_vscode_alt_monaco_editor_esm_vs_base_common_resources__WEBPACK_IMPORTED_MODULE_4__.basenameOrAuthority)(f.uri), index: undefined })));
        for (let i = 0; i < newOrganizationResources.length; i++) {
            const folder = newOrganizationResources[i];
            if (newOrganizationResources.some((otherResource, index) => index !== i && isResourceEqual(folder.uri, otherResource.uri))) {
                return false; // cannot add the same folder multiple times
            }
        }
        newOrganizationResources.forEach((f, index) => f.index = index); // fix index
        const { added, removed } = delta(currentOrganizationResources, newOrganizationResources, compareOrganizationResourceByUriAndNameAndIndex);
        if (added.length === 0 && removed.length === 0) {
            return false; // nothing actually changed
        }
        // Trigger on main side
        if (this._proxy) {
            const extName = extension.displayName || extension.name;
            this._proxy.$updateOrganizationResources(extName, index, deleteCount, validatedDistinctOrganizationResourcesToAdd).then(null, error => {
                // in case of an error, make sure to clear out the unconfirmed organization
                // because we cannot expect the acknowledgement from the main side for this
                this._unconfirmedOrganization = undefined;
                // show error to user
                // this._messageService.$showMessage(Severity.Error, localize('updateerror', "Extension '{0}' failed to update organization folders: {1}", extName, error.toString()), { extension }, []);
            });
        }
        // Try to accept directly
        this.trySetOrganizationResources(newOrganizationResources);
        return true;
    }
    getOrganizationResource(uri, resolveParent) {
        if (!this._actualOrganization) {
            return undefined;
        }
        return this._actualOrganization.getOrganizationResource(uri, resolveParent);
    }
    async getOrganizationResource2(uri, resolveParent) {
        await this._barrier.wait();
        if (!this._actualOrganization) {
            return undefined;
        }
        return this._actualOrganization.getOrganizationResource(uri, resolveParent);
    }
    async resolveOrganizationResource(uri) {
        await this._barrier.wait();
        if (!this._actualOrganization) {
            return undefined;
        }
        return this._actualOrganization.resolveOrganizationResource(uri);
    }
    getPath() {
        // this is legacy from the days before having
        // multi-root and we keep it only alive if there
        // is just one organization folder.
        if (!this._actualOrganization) {
            return undefined;
        }
        const { resources } = this._actualOrganization;
        if (resources.length === 0) {
            return undefined;
        }
        // #54483 @Joh Why are we still using fsPath?
        return resources[0].uri.fsPath;
    }
    getRelativePath(pathOrUri, includeOrganization) {
        let resource;
        let path = '';
        if (typeof pathOrUri === 'string') {
            resource = _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_6__.URI.file(pathOrUri);
            path = pathOrUri;
        }
        else if (typeof pathOrUri !== 'undefined') {
            resource = pathOrUri;
            path = pathOrUri.fsPath;
        }
        if (!resource) {
            return path;
        }
        const folder = this.getOrganizationResource(resource, true);
        if (!folder) {
            return path;
        }
        if (typeof includeOrganization === 'undefined' && this._actualOrganization) {
            includeOrganization = this._actualOrganization.resources.length > 1;
        }
        let result = (0,_vscode_alt_monaco_editor_esm_vs_base_common_resources__WEBPACK_IMPORTED_MODULE_4__.relativePath)(folder.uri, resource);
        if (includeOrganization && folder.name) {
            result = `${folder.name}/${result}`;
        }
        return result;
    }
    trySetOrganizationResources(resources) {
        // Update directly here. The organization is unconfirmed as long as we did not get an
        // acknowledgement from the main side (via $acceptOrganizationData)
        if (this._actualOrganization) {
            this._unconfirmedOrganization = ExtHostOrganizationImpl.toExtHostOrganization({
                id: this._actualOrganization.id,
                name: this._actualOrganization.name,
                configuration: this._actualOrganization.configuration,
                resources
            }, this._actualOrganization).organization;
        }
    }
    $acceptOrganizationData(data) {
        const { organization, added, removed } = ExtHostOrganizationImpl.toExtHostOrganization(data, this._confirmedOrganization, this._unconfirmedOrganization);
        // Update our organization object. We have a confirmed organization, so we drop our
        // unconfirmed organization.
        this._confirmedOrganization = organization;
        this._unconfirmedOrganization = undefined;
        // Events
        this._onDidChangeOrganization.fire(Object.freeze({
            added,
            removed,
        }));
    }
    saveAll(includeUntitled) {
        return this._proxy.$saveAll(includeUntitled);
    }
    resolveProxy(url) {
        return this._proxy.$resolveProxy(url);
    }
}


/***/ }),

/***/ "./src/api/ext-host/extension-host.ts":
/*!********************************************!*\
  !*** ./src/api/ext-host/extension-host.ts ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "startExtensionHost": () => (/* binding */ startExtensionHost)
/* harmony export */ });
/* harmony import */ var reflect_metadata__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! reflect-metadata */ "reflect-metadata");
/* harmony import */ var reflect_metadata__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(reflect_metadata__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! rxjs */ "rxjs");
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(rxjs__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var graphql_tag__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! graphql-tag */ "graphql-tag");
/* harmony import */ var graphql_tag__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(graphql_tag__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @adminide-stack/extension-api */ "@adminide-stack/extension-api");
/* harmony import */ var _adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _ext_host_context__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./ext-host-context */ "./src/api/ext-host/ext-host-context.ts");
/* harmony import */ var _ext_host_extension_service__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./ext-host-extension-service */ "./src/api/ext-host/ext-host-extension-service.ts");
/* harmony import */ var _ext_host_client_configuration__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./ext-host-client-configuration */ "./src/api/ext-host/ext-host-client-configuration.ts");
/* harmony import */ var _ext_host_client_configuration_policy__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./ext-host-client-configuration-policy */ "./src/api/ext-host/ext-host-client-configuration-policy.ts");
/* harmony import */ var _ext_host_client_configuration_role__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./ext-host-client-configuration-role */ "./src/api/ext-host/ext-host-client-configuration-role.ts");
/* harmony import */ var _ext_host_organization__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./ext-host-organization */ "./src/api/ext-host/ext-host-organization.ts");
/* harmony import */ var _adminide_stack_extension_api_lib_core_types__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @adminide-stack/extension-api/lib/core/types */ "@adminide-stack/extension-api/lib/core/types");
/* harmony import */ var _adminide_stack_extension_api_lib_core_types__WEBPACK_IMPORTED_MODULE_10___default = /*#__PURE__*/__webpack_require__.n(_adminide_stack_extension_api_lib_core_types__WEBPACK_IMPORTED_MODULE_10__);
/* harmony import */ var _apollo_client__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @apollo/client */ "@apollo/client");
/* harmony import */ var _apollo_client__WEBPACK_IMPORTED_MODULE_11___default = /*#__PURE__*/__webpack_require__.n(_apollo_client__WEBPACK_IMPORTED_MODULE_11__);
/* harmony import */ var subscriptions_transport_ws__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! subscriptions-transport-ws */ "subscriptions-transport-ws");
/* harmony import */ var subscriptions_transport_ws__WEBPACK_IMPORTED_MODULE_12___default = /*#__PURE__*/__webpack_require__.n(subscriptions_transport_ws__WEBPACK_IMPORTED_MODULE_12__);
/* harmony import */ var _apollo_client_link_ws__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @apollo/client/link/ws */ "@apollo/client/link/ws");
/* harmony import */ var _apollo_client_link_ws__WEBPACK_IMPORTED_MODULE_13___default = /*#__PURE__*/__webpack_require__.n(_apollo_client_link_ws__WEBPACK_IMPORTED_MODULE_13__);
/* harmony import */ var _apollo_client_cache__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @apollo/client/cache */ "@apollo/client/cache");
/* harmony import */ var _apollo_client_cache__WEBPACK_IMPORTED_MODULE_14___default = /*#__PURE__*/__webpack_require__.n(_apollo_client_cache__WEBPACK_IMPORTED_MODULE_14__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/uri */ "@vscode-alt/monaco-editor/esm/vs/base/common/uri");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_15___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_15__);
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_numbers__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @vscode-alt/monaco-editor/esm/vs/base/common/numbers */ "@vscode-alt/monaco-editor/esm/vs/base/common/numbers");
/* harmony import */ var _vscode_alt_monaco_editor_esm_vs_base_common_numbers__WEBPACK_IMPORTED_MODULE_16___default = /*#__PURE__*/__webpack_require__.n(_vscode_alt_monaco_editor_esm_vs_base_common_numbers__WEBPACK_IMPORTED_MODULE_16__);
/* harmony import */ var _adminide_stack_extension_api_lib_protocol_server_protocol__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @adminide-stack/extension-api/lib/protocol/server.protocol */ "@adminide-stack/extension-api/lib/protocol/server.protocol");
/* harmony import */ var _adminide_stack_extension_api_lib_protocol_server_protocol__WEBPACK_IMPORTED_MODULE_17___default = /*#__PURE__*/__webpack_require__.n(_adminide_stack_extension_api_lib_protocol_server_protocol__WEBPACK_IMPORTED_MODULE_17__);
/* harmony import */ var _adminide_stack_extension_api_lib_protocol_rpc_protocol__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @adminide-stack/extension-api/lib/protocol/rpc-protocol */ "@adminide-stack/extension-api/lib/protocol/rpc-protocol");
/* harmony import */ var _adminide_stack_extension_api_lib_protocol_rpc_protocol__WEBPACK_IMPORTED_MODULE_18___default = /*#__PURE__*/__webpack_require__.n(_adminide_stack_extension_api_lib_protocol_rpc_protocol__WEBPACK_IMPORTED_MODULE_18__);
/* harmony import */ var _adminide_stack_extension_api_lib_protocol_rpc_logger__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! @adminide-stack/extension-api/lib/protocol/rpc-logger */ "@adminide-stack/extension-api/lib/protocol/rpc-logger");
/* harmony import */ var _adminide_stack_extension_api_lib_protocol_rpc_logger__WEBPACK_IMPORTED_MODULE_19___default = /*#__PURE__*/__webpack_require__.n(_adminide_stack_extension_api_lib_protocol_rpc_logger__WEBPACK_IMPORTED_MODULE_19__);
/* harmony import */ var _adminide_stack_extension_api_lib_connections_remote_rpc__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! @adminide-stack/extension-api/lib/connections/remote-rpc */ "@adminide-stack/extension-api/lib/connections/remote-rpc");
/* harmony import */ var _adminide_stack_extension_api_lib_connections_remote_rpc__WEBPACK_IMPORTED_MODULE_20___default = /*#__PURE__*/__webpack_require__.n(_adminide_stack_extension_api_lib_connections_remote_rpc__WEBPACK_IMPORTED_MODULE_20__);
/* harmony import */ var _cdm_logger_client__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! @cdm-logger/client */ "@cdm-logger/client");
/* harmony import */ var _cdm_logger_client__WEBPACK_IMPORTED_MODULE_21___default = /*#__PURE__*/__webpack_require__.n(_cdm_logger_client__WEBPACK_IMPORTED_MODULE_21__);
/* tslint:disable */






















// import { WebExtHostEditorWindows } from './ext-editor-windows';

const consoleLogger = {
    error(message) {
        console.error(message);
    },
    warn(message) {
        console.warn(message);
    },
    info(message) {
        console.info(message);
    },
    log(message) {
        console.log(message);
    },
};
/**
 * Starts the extension host, which runs extensions. It is a Web Worker or other similar isolated
 * JavaScript execution context. There is exactly 1 extension hsot, and it has zeor or more
 * extensions activated (and running).
 *
 * It expects to receive a message containing {@link IInitData} from the client application as the
 * first message.
 *
 * @param transports The message reader and writer to use for communication with the client.
 * @return An unsubscribable to terminate the extension host.
 */
function startExtensionHost(transports, enableBackendConnection = false) {
    const connection = (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.createConnection)(transports, consoleLogger);
    connection.listen();
    const subscription = new rxjs__WEBPACK_IMPORTED_MODULE_1__.Subscription();
    subscription.add(connection);
    // Wait for "initialize" message from client application before proceeding to create the
    // extension host.
    let initialized = false;
    const extensionAPI = new Promise(resolve => {
        connection.onRequest('initialize', async ([initData]) => {
            if (initialized) {
                throw new Error('extension host is already initialized');
            }
            initialized = true;
            let serverApi, remoteRPC;
            if (enableBackendConnection) {
                // graphql
                // setup websocket connection
                const apolloSubscription = new subscriptions_transport_ws__WEBPACK_IMPORTED_MODULE_12__.SubscriptionClient(initData.graphqlSubscriptionUrl, {
                    reconnect: true,
                });
                const link = new _apollo_client_link_ws__WEBPACK_IMPORTED_MODULE_13__.WebSocketLink(apolloSubscription);
                serverApi = new _apollo_client__WEBPACK_IMPORTED_MODULE_11__.ApolloClient({
                    link,
                    cache: new _apollo_client_cache__WEBPACK_IMPORTED_MODULE_14__.InMemoryCache(),
                });
                const remoteConnection = new _adminide_stack_extension_api_lib_connections_remote_rpc__WEBPACK_IMPORTED_MODULE_20__.BrowserRemoteRPC();
                remoteConnection.connect(initData.extensionSocketUrl, () => {
                    const socket = new WebSocket(initData.extensionSocketUrl);
                    socket.binaryType = 'arraybuffer';
                    return socket;
                });
                remoteRPC = new _adminide_stack_extension_api_lib_protocol_rpc_protocol__WEBPACK_IMPORTED_MODULE_18__.RPCProtocol(remoteConnection, 2 /* HostIdentifier.BrowserExtHost */, new _adminide_stack_extension_api_lib_protocol_rpc_logger__WEBPACK_IMPORTED_MODULE_19__.RPCLogger(), null);
            }
            const searchRequestIdProvider = new _vscode_alt_monaco_editor_esm_vs_base_common_numbers__WEBPACK_IMPORTED_MODULE_16__.Counter();
            const extHostOrganization = new _ext_host_organization__WEBPACK_IMPORTED_MODULE_9__.WebExtHostOrganization((0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.createProxy)(connection, 'organization'), initData.organization, _cdm_logger_client__WEBPACK_IMPORTED_MODULE_21__.logger, searchRequestIdProvider);
            (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.handleRequests)(connection, 'organization', extHostOrganization);
            const configuration = new _ext_host_client_configuration__WEBPACK_IMPORTED_MODULE_6__.WebExtHostConfiguration((0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.createProxy)(connection, 'configuration'), extHostOrganization);
            (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.handleRequests)(connection, 'configuration', configuration);
            // const configProvider = await configuration.getConfigProvider();
            const { unsubscribe, extensionAPI } = await initializeExtensionHost(connection, initData, remoteRPC, serverApi);
            subscription.add(unsubscribe);
            resolve(extensionAPI);
        });
    });
    return { unsubscribe: () => subscription.unsubscribe(), extensionAPI };
}
/**
 * Initializes the extension host using the {@link IInitData} from the client application. It is
 * called by {@link startExtensionHost} after the {@link IInitData} is received.
 *
 * The extension API is made globally avaialble to all requires/imports of the "cdeops" module
 * by other scripts running in the same JavaScript context.
 * @param connection The connection used to communicate with client.
 * @param initData The information to initialize theis extension host.
 * @return An unsubscribable to terminate the extension host.
 */
function initializeExtensionHost(connection, initData, remoteRPC, serverApi) {
    const subscriptions = new rxjs__WEBPACK_IMPORTED_MODULE_1__.Subscription();
    // Workaround for different envs
    var globalObject = typeof window !== 'undefined' ? window :
        typeof self !== 'undefined' ? self :
            typeof __webpack_require__.g !== 'undefined' ? __webpack_require__.g :
                {};
    // step 1: attach organizationData to initData
    const { api, subscription: apiSubscription } = createExtensionAPI(initData, connection, remoteRPC, serverApi);
    subscriptions.add(apiSubscription);
    // Make `import 'cdeops'` or `require('cdeops')` return the extension API.
    globalObject.require = (modulePath) => {
        if (modulePath === 'cdeops/client') {
            return api;
        }
        // All other requires/imports in the extenion's code should not reach here because their JS
        // bundler should have resolved them locally.
        throw new Error(`require: module not found: ${modulePath}`);
    };
    subscriptions.add(() => {
        globalObject.require = () => {
            // Prevent callers from attempting to access the extension API after it was
            // unsubscribed.
            throw new Error(`require: Cdecode extension API was unsubscribed`);
        };
    });
    return { unsubscribe: () => {
            return subscriptions.unsubscribe();
        }, extensionAPI: api };
}
function createExtensionAPI(initData, connection, rpcProtocol, serverApi) {
    const subscriptions = new rxjs__WEBPACK_IMPORTED_MODULE_1__.Subscription();
    // For debugging/tests.
    const sync = () => connection.sendRequest('ping');
    connection.onRequest('ping', () => 'pong');
    const context = new _ext_host_context__WEBPACK_IMPORTED_MODULE_4__.ExtHostContext((0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.createProxy)(connection, 'context'));
    (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.handleRequests)(connection, 'context', context);
    const extensions = new _ext_host_extension_service__WEBPACK_IMPORTED_MODULE_5__.WebExtHostExtensionService();
    subscriptions.add(extensions);
    (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.handleRequests)(connection, 'extensions', extensions);
    // const commands = new WebExtHostCommands(createProxy(connection, 'commands'));
    // subscriptions.add(commands);
    // handleRequests(connection, 'commands', commands);
    const searchRequestIdProvider = new _vscode_alt_monaco_editor_esm_vs_base_common_numbers__WEBPACK_IMPORTED_MODULE_16__.Counter();
    const extHostOrganization = new _ext_host_organization__WEBPACK_IMPORTED_MODULE_9__.WebExtHostOrganization((0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.createProxy)(connection, 'organization'), initData.organization, _cdm_logger_client__WEBPACK_IMPORTED_MODULE_21__.logger, searchRequestIdProvider);
    (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.handleRequests)(connection, 'organization', extHostOrganization);
    const configuration = new _ext_host_client_configuration__WEBPACK_IMPORTED_MODULE_6__.WebExtHostConfiguration((0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.createProxy)(connection, 'configuration'), extHostOrganization);
    (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.handleRequests)(connection, 'configuration', configuration);
    // const configProvider =  await configuration.getConfigProvider();
    const configurationRole = new _ext_host_client_configuration_role__WEBPACK_IMPORTED_MODULE_8__.WebExtHostConfigurationRole((0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.createProxy)(connection, 'configurationRole'), extHostOrganization);
    (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.handleRequests)(connection, 'configurationRole', configurationRole);
    const configurationPolicy = new _ext_host_client_configuration_policy__WEBPACK_IMPORTED_MODULE_7__.WebExtHostConfigurationPolicy((0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.createProxy)(connection, 'configurationPolicy'), extHostOrganization);
    (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.handleRequests)(connection, 'configurationPolicy', configurationPolicy);
    // namespace: organization
    const organization = {
        get rootPath() {
            return extHostOrganization.getPath();
        },
        set rootPath(value) {
            throw Error('readonly');
        },
        getOrganizationResource(resource) {
            return extHostOrganization.getOrganizationResource(resource);
        },
        get organizationResources() {
            return extHostOrganization.getOrganizationResources();
        },
        get name() {
            return extHostOrganization.name;
        },
        set name(value) {
            throw Error('readonly');
        },
        updateOrganizationResources: (index, deleteCount, ...workspaceFoldersToAdd) => {
            return extHostOrganization.updateOrganizationResources(/**extension**/ null, index, deleteCount || 0, ...workspaceFoldersToAdd);
        },
        onDidChangeOrganizationResources: function (listener, thisArgs, disposables) {
            return extHostOrganization.onDidChangeOrganization(listener, thisArgs, disposables);
        },
        onDidChangeConfiguration: null,
        getConfiguration(section, resource) {
            throw Error('not configured');
        },
        // onDidChangeConfiguration: configProvider.onDidChangeConfiguration,
        // getConfiguration(section?: string, resource?: cdeops.URI) {
        //     resource = arguments.length === 1 ? undefined : resource;
        //     return configProvider.getConfiguration(section, resource, /** extension.identifier **/ null);
        // },
        onDidChangeConfigurationRole: (listener, thisArgs, disposables) => {
            throw Error('not ready');
        },
        getConfigurationRole(section, resource) {
            throw Error('not ready');
        },
        onDidChangeConfigurationPolicy: (listener, thisArgs, disposables) => {
            throw Error('not ready');
        },
        getConfigurationPolicy(section, resource) {
            throw Error('not ready');
        }
    };
    if (rpcProtocol) {
        // remote connections
        // commneted as of 05/17/2019
        (0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_3__.handleServerProxyRequests)(connection, rpcProtocol, _adminide_stack_extension_api_lib_protocol_server_protocol__WEBPACK_IMPORTED_MODULE_17__.ExtHostContext);
        /**
         * Register to the ClientThread classes via `Connection`.
         * The request from the server side ExtHost will be directly forwarded to Client Thread.
         */
        // rpcProtocol.set(MainContext.MainThreadTreeViews, createProxy(connection, 'treeViews'));
        // rpcProtocol.set(MainContext.MainThreadLanguageFeatures, createProxy(connection, 'languageFeatures'));
    }
    const api = {
        // version: pkg.version,
        // commands: {
        //     registerCommand: (command, callback) => commands.registerCommand({ command, callback }),
        //     executeCommand: (command, ...args) => commands.executeCommand(command, args),
        // },
        configuration: {},
        organization,
        // types
        // Color: extHostTypes.Color,
        ConfigurationTarget: _adminide_stack_extension_api_lib_core_types__WEBPACK_IMPORTED_MODULE_10__.ConfigurationTarget,
        LogLevel: _adminide_stack_extension_api_lib_core_types__WEBPACK_IMPORTED_MODULE_10__.LogLevel,
        // ThemeColor: extHostTypes.ThemeColor,
        // ThemeIcon: extHostTypes.ThemeIcon,
        RelativePattern: _adminide_stack_extension_api_lib_core_types__WEBPACK_IMPORTED_MODULE_10__.RelativePattern,
        URI: _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_15__.URI,
        // ViewColumn: extHostTypes.ViewColumn,
        // WorkspaceEdit: extHostTypes.WorkspaceEdit,
        internal: {
            updateContext: (updates) => context.updateContext(updates),
            cdeopsURL: _vscode_alt_monaco_editor_esm_vs_base_common_uri__WEBPACK_IMPORTED_MODULE_15__.URI.parse(initData.cdeopsURL),
            clientApplication: initData.clientApplication,
            sync,
            serverApi,
            gql: (graphql_tag__WEBPACK_IMPORTED_MODULE_2___default()),
        }
    };
    return { api, subscription: subscriptions };
}


/***/ }),

/***/ "./src/util/event-pipes.ts":
/*!*********************************!*\
  !*** ./src/util/event-pipes.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getEventPayload": () => (/* binding */ getEventPayload),
/* harmony export */   "getEvents": () => (/* binding */ getEvents)
/* harmony export */ });
const getEventPayload = event => event.payload;
const getEvents = type => (event) => event.type === type;


/***/ }),

/***/ "@adminide-stack/core":
/*!***************************************!*\
  !*** external "@adminide-stack/core" ***!
  \***************************************/
/***/ ((module) => {

module.exports = require("@adminide-stack/core");

/***/ }),

/***/ "@adminide-stack/extension-api":
/*!************************************************!*\
  !*** external "@adminide-stack/extension-api" ***!
  \************************************************/
/***/ ((module) => {

module.exports = require("@adminide-stack/extension-api");

/***/ }),

/***/ "@adminide-stack/extension-api/lib/connections/remote-rpc":
/*!***************************************************************************!*\
  !*** external "@adminide-stack/extension-api/lib/connections/remote-rpc" ***!
  \***************************************************************************/
/***/ ((module) => {

module.exports = require("@adminide-stack/extension-api/lib/connections/remote-rpc");

/***/ }),

/***/ "@adminide-stack/extension-api/lib/core/types":
/*!***************************************************************!*\
  !*** external "@adminide-stack/extension-api/lib/core/types" ***!
  \***************************************************************/
/***/ ((module) => {

module.exports = require("@adminide-stack/extension-api/lib/core/types");

/***/ }),

/***/ "@adminide-stack/extension-api/lib/core/types/ext-host-types":
/*!******************************************************************************!*\
  !*** external "@adminide-stack/extension-api/lib/core/types/ext-host-types" ***!
  \******************************************************************************/
/***/ ((module) => {

module.exports = require("@adminide-stack/extension-api/lib/core/types/ext-host-types");

/***/ }),

/***/ "@adminide-stack/extension-api/lib/protocol/rpc-logger":
/*!************************************************************************!*\
  !*** external "@adminide-stack/extension-api/lib/protocol/rpc-logger" ***!
  \************************************************************************/
/***/ ((module) => {

module.exports = require("@adminide-stack/extension-api/lib/protocol/rpc-logger");

/***/ }),

/***/ "@adminide-stack/extension-api/lib/protocol/rpc-protocol":
/*!**************************************************************************!*\
  !*** external "@adminide-stack/extension-api/lib/protocol/rpc-protocol" ***!
  \**************************************************************************/
/***/ ((module) => {

module.exports = require("@adminide-stack/extension-api/lib/protocol/rpc-protocol");

/***/ }),

/***/ "@adminide-stack/extension-api/lib/protocol/server.protocol":
/*!*****************************************************************************!*\
  !*** external "@adminide-stack/extension-api/lib/protocol/server.protocol" ***!
  \*****************************************************************************/
/***/ ((module) => {

module.exports = require("@adminide-stack/extension-api/lib/protocol/server.protocol");

/***/ }),

/***/ "@apollo/client":
/*!*********************************!*\
  !*** external "@apollo/client" ***!
  \*********************************/
/***/ ((module) => {

module.exports = require("@apollo/client");

/***/ }),

/***/ "@apollo/client/cache":
/*!***************************************!*\
  !*** external "@apollo/client/cache" ***!
  \***************************************/
/***/ ((module) => {

module.exports = require("@apollo/client/cache");

/***/ }),

/***/ "@apollo/client/link/ws":
/*!*****************************************!*\
  !*** external "@apollo/client/link/ws" ***!
  \*****************************************/
/***/ ((module) => {

module.exports = require("@apollo/client/link/ws");

/***/ }),

/***/ "@cdm-logger/client":
/*!*************************************!*\
  !*** external "@cdm-logger/client" ***!
  \*************************************/
/***/ ((module) => {

module.exports = require("@cdm-logger/client");

/***/ }),

/***/ "@vscode-alt/monaco-editor/esm/vs/base/common/arrays":
/*!**********************************************************************!*\
  !*** external "@vscode-alt/monaco-editor/esm/vs/base/common/arrays" ***!
  \**********************************************************************/
/***/ ((module) => {

module.exports = require("@vscode-alt/monaco-editor/esm/vs/base/common/arrays");

/***/ }),

/***/ "@vscode-alt/monaco-editor/esm/vs/base/common/async":
/*!*********************************************************************!*\
  !*** external "@vscode-alt/monaco-editor/esm/vs/base/common/async" ***!
  \*********************************************************************/
/***/ ((module) => {

module.exports = require("@vscode-alt/monaco-editor/esm/vs/base/common/async");

/***/ }),

/***/ "@vscode-alt/monaco-editor/esm/vs/base/common/event":
/*!*********************************************************************!*\
  !*** external "@vscode-alt/monaco-editor/esm/vs/base/common/event" ***!
  \*********************************************************************/
/***/ ((module) => {

module.exports = require("@vscode-alt/monaco-editor/esm/vs/base/common/event");

/***/ }),

/***/ "@vscode-alt/monaco-editor/esm/vs/base/common/map":
/*!*******************************************************************!*\
  !*** external "@vscode-alt/monaco-editor/esm/vs/base/common/map" ***!
  \*******************************************************************/
/***/ ((module) => {

module.exports = require("@vscode-alt/monaco-editor/esm/vs/base/common/map");

/***/ }),

/***/ "@vscode-alt/monaco-editor/esm/vs/base/common/numbers":
/*!***********************************************************************!*\
  !*** external "@vscode-alt/monaco-editor/esm/vs/base/common/numbers" ***!
  \***********************************************************************/
/***/ ((module) => {

module.exports = require("@vscode-alt/monaco-editor/esm/vs/base/common/numbers");

/***/ }),

/***/ "@vscode-alt/monaco-editor/esm/vs/base/common/objects":
/*!***********************************************************************!*\
  !*** external "@vscode-alt/monaco-editor/esm/vs/base/common/objects" ***!
  \***********************************************************************/
/***/ ((module) => {

module.exports = require("@vscode-alt/monaco-editor/esm/vs/base/common/objects");

/***/ }),

/***/ "@vscode-alt/monaco-editor/esm/vs/base/common/platform":
/*!************************************************************************!*\
  !*** external "@vscode-alt/monaco-editor/esm/vs/base/common/platform" ***!
  \************************************************************************/
/***/ ((module) => {

module.exports = require("@vscode-alt/monaco-editor/esm/vs/base/common/platform");

/***/ }),

/***/ "@vscode-alt/monaco-editor/esm/vs/base/common/resources":
/*!*************************************************************************!*\
  !*** external "@vscode-alt/monaco-editor/esm/vs/base/common/resources" ***!
  \*************************************************************************/
/***/ ((module) => {

module.exports = require("@vscode-alt/monaco-editor/esm/vs/base/common/resources");

/***/ }),

/***/ "@vscode-alt/monaco-editor/esm/vs/base/common/strings":
/*!***********************************************************************!*\
  !*** external "@vscode-alt/monaco-editor/esm/vs/base/common/strings" ***!
  \***********************************************************************/
/***/ ((module) => {

module.exports = require("@vscode-alt/monaco-editor/esm/vs/base/common/strings");

/***/ }),

/***/ "@vscode-alt/monaco-editor/esm/vs/base/common/types":
/*!*********************************************************************!*\
  !*** external "@vscode-alt/monaco-editor/esm/vs/base/common/types" ***!
  \*********************************************************************/
/***/ ((module) => {

module.exports = require("@vscode-alt/monaco-editor/esm/vs/base/common/types");

/***/ }),

/***/ "@vscode-alt/monaco-editor/esm/vs/base/common/uri":
/*!*******************************************************************!*\
  !*** external "@vscode-alt/monaco-editor/esm/vs/base/common/uri" ***!
  \*******************************************************************/
/***/ ((module) => {

module.exports = require("@vscode-alt/monaco-editor/esm/vs/base/common/uri");

/***/ }),

/***/ "graphql-tag":
/*!******************************!*\
  !*** external "graphql-tag" ***!
  \******************************/
/***/ ((module) => {

module.exports = require("graphql-tag");

/***/ }),

/***/ "reflect-metadata":
/*!***********************************!*\
  !*** external "reflect-metadata" ***!
  \***********************************/
/***/ ((module) => {

module.exports = require("reflect-metadata");

/***/ }),

/***/ "rxjs":
/*!***********************!*\
  !*** external "rxjs" ***!
  \***********************/
/***/ ((module) => {

module.exports = require("rxjs");

/***/ }),

/***/ "rxjs/operators":
/*!*********************************!*\
  !*** external "rxjs/operators" ***!
  \*********************************/
/***/ ((module) => {

module.exports = require("rxjs/operators");

/***/ }),

/***/ "subscriptions-transport-ws":
/*!*********************************************!*\
  !*** external "subscriptions-transport-ws" ***!
  \*********************************************/
/***/ ((module) => {

module.exports = require("subscriptions-transport-ws");

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
/*!***********************************************!*\
  !*** ./src/extensions/workers/main.worker.ts ***!
  \***********************************************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _api_ext_host_extension_host__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../api/ext-host/extension-host */ "./src/api/ext-host/extension-host.ts");
/* harmony import */ var _adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @adminide-stack/extension-api */ "@adminide-stack/extension-api");
/* harmony import */ var _adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_1__);


/**
 * The entrypoint for the JavaScript context that runs the extension host (and all extensions).
 *
 * To initialize the extension host, the parent sends it an 'initialize' message with
 * {@link InitData}.
 */
async function extensionHostMain() {
    try {
        const { unsubscribe } = (0,_api_ext_host_extension_host__WEBPACK_IMPORTED_MODULE_0__.startExtensionHost)((0,_adminide_stack_extension_api__WEBPACK_IMPORTED_MODULE_1__.createWebWorkerMessageTransports)(), false /**true disable server side */);
        self.addEventListener('unload', () => unsubscribe());
    }
    catch (err) {
        console.error('Error starting the extension host:', err);
        self.close();
    }
}
extensionHostMain();

})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=main.worker.index.js.map